#lang racket


;;;; 9. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 7.5.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - metainterpreter programovacieho jazyka LISP,
;;;; - príprava na semestrálny test.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;; Pozri tiež súbor priprava_na_test.txt

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Zoznamy.

;;; Sekcia. Kombinatorika na zoznamoch.

;; Definícia. Rozkladom zoznamu rozumieme dvojicu zoznamov, ktorej zreťazením
;; dostaneme pôvodný zoznam.
;;   Príklad: (cons '(1 2 3) '(4 5)) je rozkladom zoznamu '(1 2 3 4 5).

;; Úloha. Implementujte program, ktorý vráti všetky rozklady daného zoznamu.
;; Výsledok reprezentujte ako zoznam rozkladov.

(define (partitions xs) ...)

;; (partitions '())
;; (partitions '(1))
;; (partitions '(1 2))
;; (partitions '(1 2 3))
;; (partitions '(1 2 3 4))
;; (partitions '(1 2 3 4 5))

;; Definícia. Kompozíciou prirodzeného čísla rozumieme taký zoznam nenulových
;; prirodzených čísel, ktorých sčítaním dostaneme pôvodné číslo.
;;   Príklad: '(2 2 1)  a '(1 4) sú kompozície čísla 5.

;; Úloha. Implementujte program, ktorý vráti všetky kompozície daného čísla.
;; Výsledok reprezentujte ako zoznam kompozícií.

(define (compositions n) ...)

;; (compositions 0)
;; (compositions 1)
;; (compositions 2)
;; (compositions 3)
;; (compositions 4)
;; (compositions 5)
